with Ada.Text_IO, Messages, Reps, Linear, Linear.IO, Parameters;
use Ada.Text_IO, Messages, Reps, Linear, Linear.IO, Parameters;

--with Numerics,Numerics.Ops,Numerics.IO;  -- CHOICE
--use  Numerics,Numerics.Ops,Numerics.IO;  -- CHOICE

with Intervals,Intervals.Ops,Intervals.IO;  -- CHOICE
use  Intervals,Intervals.Ops,Intervals.IO;  -- CHOICE

with Fpu;

procedure Check_Fix is

-- arguments: Size PartSize q-filename m-filename

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   package Txt_Rep_IO is new Ada.Text_IO.Float_IO(Rep);

   subtype Scalar is Interval;  -- CHOICE


   Size:     constant Positive := GetArg(1);
   PartSize: constant Positive := GetArg(2);
   QName:    constant String   := GetArg(3);  -- q file
   MName:    constant String   := GetArg(4);  -- m file
   R1:       constant Radius   := GetArg(5);  -- radius of analyticity
   R2:       constant Radius   := GetArg(6);  -- radius of the ball

   Number: Positive;
   Freq: Rep;
   F: File_Type;

begin
   Open(F,In_File,QName);
   Txt_Rep_IO.Get(F,Freq);
   Txt_Int_IO.Get(F,Number);
   Close(F);
   Sol :=  GetArg(7);
   Display := True;

   declare
      package CFFpu is new Fpu (Number => Number, Size => Size, PartSize => PartSize, Scalar => Scalar);
      use CFFpu, CFFpu.Qf, CFFpu.Qf_IO, CFFpu.Qf_Ops;

      pragma Suppress(Storage_Check);

      M: Matrix(PartIndex,PartIndex);
      H: Q;
      FreqS: Scalar;

   begin
      Trace;                            -- activate TraceEnter/TraceLeave
      ShowParam;
      Show("   domain of H:",R1);
      Show("radius of ball:",R2);

      Read(QName,1,H);
      FreqS := Scal(0.1989);
      if Qname="K-ro" or Qname="C-rq" then
         FreqS := Scal(2)*FreqS;
      end if;
      if Qname="J-rq" then
         FreqS := Scal(9)*FreqS;
      end if;
      if Qname="F-ro" then
         FreqS := Scal(10)*FreqS;
      end if;
      if Qname="Lh" then
         FreqS := Scal(1);
      end if;
      SetFrequency(FreqS,H);
      SetRho(R1,H);
      Read(MName,M);

      CheckFix(M,H,R2);
   end;

end Check_Fix;
