with Ada.Text_IO,Reps.IO;
use Ada.Text_IO,Reps.IO;

pragma Elaborate_All (Ada.Text_IO);

generic

  with procedure Show(S: in Scalar; NewLine: in Boolean := True) is <>;
  with procedure Get(F: in File_Type; S: out Scalar; Decimal: in Boolean := True) is <>;
  with procedure Put(F: in File_Type; S: in Scalar; Decimal: in Boolean := True) is <>;

package Fouriers.IO is

   procedure Show(H: in Fourier; Cut: in Rep := Zero);
-- Show coeffs of H  (of modulus>Cut)
   procedure Write(Name: in String;H: in Fourier; Decimal: in Boolean := True);
-- Write H to file Name
   procedure Put(F: in File_Type;H: in  Fourier;Decimal: in Boolean := True);
-- Write H to file F
   procedure Read(Name: in String; J: in Parity;
                                   H: out Fourier; Decimal: in Boolean := True);
-- Read H from file Name
   procedure Get(F: in File_Type; J: in Parity;
                                  H: out Fourier; Decimal: in Boolean := True);
-- Read H from file F

end Fouriers.IO;
