generic

package Fouriers.Ops is

   function "+"(H1,H2 : Fourier) return Fourier;
   function "-"(H1,H2 : Fourier) return Fourier;
   function "-"(H1 : Fourier) return Fourier;
   function "*"(S: Scalar; H: Fourier) return Fourier;  -- S*H
   function "*"(H1,H2: Fourier) return Fourier;         -- H*H
-- 2*sin(a)*sin(b)=cos(a-b)-cos(a+b)
-- 2*cos(a)*cos(b)=cos(a-b)+cos(a+b)
-- 2*sin(a)*cos(b)=sin(a-b)+sin(a+b)
   function Norm(H: Fourier) return Scalar;   -- ||H||_Rho(H)  upper bound
   function Norm2(H: Fourier) return Scalar;   -- ||H||_2
   function MDm2(H: Fourier) return Fourier;            -- MDm2 := -D^(-2)H
   procedure GuessRho(H: in Fourier; R: out Rep);       -- guess domain of analyticity
   function Antisymm(H: Fourier) return Fourier;        -- H(t)->-H(pi-t)
   function Antisymm2(H: Fourier) return Fourier;        -- H(t)->-H(pi-t)

end Fouriers.Ops;
