package Intervals.Ops is

  pragma Elaborate_Body;

  function Ball(S: Interval) return Interval;
  function Inf(S: Interval) return Rep;
  function Sup(S: Interval) return Rep;
  function SupAbs(S: Interval) return Rep;
  function "abs"(S: Interval) return Interval;
  function Min(S1,S2: Interval) return Interval;
  function Max(S1,S2: Interval) return Interval;

  function "+"(S,T: Interval) return Interval;
  function "-"(S,T: Interval) return Interval;
  function "*"(R: Rep; S: Interval) return Interval;
  function "/"(S: Interval; R: Rep) return Interval;
  function Sqr(S: Interval) return Interval;
  function "*"(S,T: Interval) return Interval;
  function Inv(S: Interval) return Interval;
  function "/"(S,T: Interval) return Interval;
  function "**"(S: Interval; I: Integer) return Interval;
  function Exp(S: Interval) return Interval;
  function Log(S: Interval) return Interval;

  pragma Inline (Ball,Inf,Sup,SupAbs,"abs","+","-","*",Sqr,Inv);
  pragma Inline_Always (Ball,Inf,Sup,SupAbs,"abs","+","-","*",Sqr,Inv);

private

  function Scal(R1,R2: Rep) return Interval;
  procedure CoshSinh(S: in Interval; Sc,Ss: out Interval);

end Intervals.Ops;
