with Reps;
use Reps;

package Intervals is

  pragma Pure;

  type Interval is private;

  function IsNumeric(S: Interval) return Boolean;
  function Scal(K: Integer) return Interval;
  function Scal(R: Rep) return Interval;
  function Ball(R: Rep) return Interval;
  function Approx(S: Interval) return Rep;
  function "-"(S: Interval) return Interval;

  pragma Inline (IsNumeric,Scal,Ball,Approx,"-");
  pragma Inline_Always (IsNumeric,Scal,Ball,Approx,"-");

private

  type Interval is  -- also used for balls in other spaces
    record
      C: Rep;       -- center of ball
      R: Rep;       -- radius of ball
    end record;

end Intervals;
