with Ada.Text_IO, Messages, Reps, Parameters;
use Ada.Text_IO, Messages, Reps, Parameters;

with Numerics, Numerics.Ops, Numerics.IO;
use  Numerics, Numerics.Ops, Numerics.IO;

with Fpu;

procedure Iter_Newton is

-- arguments: Size PartSize filename

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   package Txt_Rep_IO is new Ada.Text_IO.Float_IO(Rep);

   subtype Scalar is Numeric;

   R1  :  constant Radius  := 0.1;     -- radius of analyticity

   Size:     constant Positive := GetArg(1);
   PartSize: constant Positive := GetArg(2);
   QName:    constant String   := GetArg(3);
   Eps :     constant Radius   := GetArg(4);

   Number: Positive;
   Freq: Rep;
   F: File_Type;

begin
   Open(F,In_File,QName);
   Txt_Rep_IO.Get(F,Freq);
   Txt_Int_IO.Get(F,Number);
   Close(F);
   Sol :=  GetArg(5);
   Display := True;

   declare
      package INFpu is new Fpu (Number => Number, Size => Size, PartSize => PartSize, Scalar => Scalar);
      use INFpu, INFpu.Qf, INFpu.Qf_Ops, INFpu.Qf_IO;

      H: Q;

   begin
      Trace;                        -- activate TraceEnter/TraceLeave
      ShowParam;                    -- display some parameters

      Read(QName,1,H);
      SetRho(R1,H);
      Newton(Eps,H);
      Show(Norm2(H));
      Write(QName & "-final",H);
      GuessDomain(H);
   end;

end Iter_Newton;

