with Ada.Text_IO, Messages, Reps, Linear, Linear.IO, Ada.Strings, Ada.Strings.Fixed,Parameters;
use Ada.Text_IO, Messages, Reps, Linear, Linear.IO, Ada.Strings, Ada.Strings.Fixed, Parameters;

with Numerics,Numerics.Ops,Numerics.IO;
use  Numerics,Numerics.Ops,Numerics.IO;

with Fpu;

procedure Make_Matrix is

-- arguments: Size PartSize filename

   package Txt_Int_IO is new Ada.Text_IO.Integer_IO(Integer);
   package Txt_Rep_IO is new Ada.Text_IO.Float_IO(Rep);

   subtype Scalar is Numeric;

   R1  :  constant Radius  := 0.1;     -- radius of analyticity

   Size:     constant Positive := GetArg(1);
   PartSize: constant Positive := GetArg(2);
   QName:    constant String   := GetArg(3);

   Number: Positive;
   Freq: Rep;
   F: File_Type;

begin
   Open(F,In_File,QName);
   Txt_Rep_IO.Get(F,Freq);
   Txt_Int_IO.Get(F,Number);
   Close(F);

   Sol :=  GetArg(4);
   Display := True;

   declare
      package MMFpu is new Fpu (Number => Number, Size => Size, PartSize => PartSize, Scalar => Scalar);
      use MMFpu, MMFpu.Qf, MMFpu.Qf_Ops, MMFpu.Qf_IO;

      pragma Suppress(Storage_Check);

      ID: constant String := Trim(Number'Img,Both) & "-" & Trim(PartSize'Img,Both);
      M: Matrix(PartIndex,PartIndex);
      H: Q;

   begin
      Trace;                        -- activate TraceEnter/TraceLeave
      ShowParam;

      Read(QName,1,H);
      SetRho(R1,H);
      M := DFmI(H);
      Write("m-" & ID,M);
   end;

end Make_Matrix;

