with Reps;
use Reps;

package Numerics.Ops is

  pragma Pure;

  function "*"(R: Rep; S: Numeric) return Numeric;
  function "/"(S: Numeric; R: Rep) return Numeric;

  function Sqr(S: Numeric) return Numeric;
  function Inv(S: Numeric) return Numeric;
  function Exp(S: Numeric) return Numeric;
  function Log(S: Numeric) return Numeric;

  pragma Inline ("*","/",Inv);
  pragma Inline_Always ("*","/",Inv);

end Numerics.Ops;
