with Reps;
use Reps;

package Numerics is

  pragma Pure;

  type Numeric is new Rep;

  function IsNumeric(S: Numeric) return Boolean;
  function Scal(K: Integer) return Numeric;
  function Scal(R: Rep) return Numeric;
  function Ball(R: Rep) return Numeric;
  function Ball(S: Numeric) return Numeric;
  function Approx(S: Numeric) return Rep;
  function Inf(S: Numeric) return Rep renames Approx;
  function Sup(S: Numeric) return Rep renames Approx;
  function SupAbs(S: Numeric) return Rep;
  function Min(S1,S2: Numeric) return Numeric renames Numeric'Min;
  function Max(S1,S2: Numeric) return Numeric renames Numeric'Max;

  pragma Inline (IsNumeric,Scal,Ball,Approx,Inf,Sup,SupAbs,Max);
  pragma Inline_Always (IsNumeric,Scal,Ball,Approx,Inf,Sup,SupAbs,Max);

end Numerics;
