with Fouriers.IO, Ada.Text_IO;
use Ada.Text_IO;

pragma Elaborate_All (Fouriers.IO);

generic

  with procedure Show(S: in Scalar; NewLine: in Boolean := True) is <>;
  with procedure Get(F: in File_Type; S: out Scalar; Decimal: in Boolean := True) is <>;
  with procedure Put(F: in File_Type; S: in Scalar; Decimal: in Boolean := True) is <>;

package Qs.IO is

   package Components_IO is new Components.IO;
   use Components_IO;

   procedure Show(H: in Q; Cut: in Rep := Zero);
   -- Show coeffs of H  (of modulus>Cut)
   procedure Read(Name: in String; J: in Parity;
                                   H: out Q; Decimal: in Boolean := True);
   -- Read H from file Name
   procedure Write(Name: in String;H: in Q; Decimal: in Boolean := True);
   -- Write H to file Name

end Qs.IO;
