with Fouriers.Ops;

pragma Elaborate_All (Fouriers.Ops);

generic

package Qs.Ops is

  package Components_Ops is new Components.Ops;
  use Components_Ops;

  function "+"(H1,H2: Q) return Q;
  function "-"(H1,H2: Q) return Q;
  function "*"(H1,H2: Q) return Q;    -- mult componentwise
  function "*"(S: Scalar; H1: Q) return Q;
  function "*"(A: Matrix; H: Q) return Q;
  function DiffNeighM(G: Q) return Q; -- q_(i)-q_(i-1)
  function DiffNeighP(G: Q) return Q; -- q_(i+1)-q_(i)
  function MDm2(G: Q) return Q;       -- -D^(-2)
  function Norm(G: Q) return Scalar;
  function Norm2(G: Q) return Scalar;
  procedure GuessDomain(H: in Q);

end Qs.Ops;
